---
title: attr()
slug: Web/CSS/attr()
tags:
  - CSS
  - CSS Function
  - Function
  - Layout
  - Reference
  - Web
  - attr
---
<div>{{CSSRef}}</div>

<div class="notecard note"><strong>Note:</strong> The <code>attr()</code> function can be used with any CSS property, but support for properties other than {{CSSxRef("content")}} is experimental, and support for the type-or-unit parameter is sparse.</div>

<p>The <strong><code>attr()</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/CSS_Functions">function</a> is used to retrieve the value of an attribute of the selected element and use it in the stylesheet. It can also be used on <a href="/en-US/docs/Web/CSS/Pseudo-elements">pseudo-elements</a>, in which case the value of the attribute on the pseudo-element's originating element is returned.</p>

<pre class="brush: css no-line-numbers notranslate">/* Simple usage */
attr(data-count);
attr(title);

/* With type */
attr(src url);
attr(data-count number);
attr(data-width px);

/* With fallback */
attr(data-count number, 0);
attr(src url, "");
attr(data-width px, inherit);
attr(data-something, "default");
</pre>

<h2 id="Syntax">Syntax</h2>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>attribute-name</code></dt>
 <dd>Is the name of an attribute on the HTML element referenced in the CSS.</dd>
 <dt><code style="white-space: nowrap;">&lt;type-or-unit&gt;</code> {{Experimental_Inline}}</dt>
 <dd>Is a keyword representing either the type of the attribute's value, or its unit, as in HTML some attributes have implicit units. If the use of <code>&lt;type-or-unit&gt;</code> as a value for the given attribute is invalid, the <code>attr()</code> expression will be invalid too. If omitted, it defaults to <code>string</code>. The list of valid values are:
 <table class="standard-table">
  <thead>
   <tr>
    <th scope="col">Keyword</th>
    <th scope="col">Associated type</th>
    <th scope="col">Comment</th>
    <th scope="col">Default value</th>
   </tr>
  </thead>
  <tbody>
   <tr>
    <td><code>string</code></td>
    <td style="white-space: nowrap;">{{CSSxRef("&lt;string&gt;")}}</td>
    <td>The attribute value is treated as a CSS {{CSSxRef("&lt;string&gt;")}}. It is NOT reparsed, and in particular the characters are used as-is instead of CSS escapes being turned into different characters.</td>
    <td>An empty string.</td>
   </tr>
   <tr>
    <td><code>color</code> {{Experimental_Inline}}</td>
    <td style="white-space: nowrap;">{{CSSxRef("&lt;color&gt;")}}</td>
    <td>The attribute value is parsed as a hash (3- or 6-value hash) or a keyword. It must be a valid CSS {{CSSxRef("&lt;string&gt;")}} value.<br>
     Leading and trailing spaces are stripped.</td>
    <td><code>currentcolor</code></td>
   </tr>
   <tr>
    <td><code>url</code> {{Experimental_Inline}}</td>
    <td style="white-space: nowrap;">{{CSSxRef("&lt;url&gt;")}}</td>
    <td>The attribute value is parsed as a string that is used inside a CSS <code>url()</code> function.<br>
     Relative URL are resolved relatively to the original document, not relatively to the style sheet.<br>
     Leading and trailing spaces are stripped.</td>
    <td>The url <code>about:invalid</code> that points to a non-existent document with a generic error condition.</td>
   </tr>
   <tr>
    <td><code>integer</code> {{Experimental_Inline}}</td>
    <td style="white-space: nowrap;">{{CSSxRef("&lt;integer&gt;")}}</td>
    <td>The attribute value is parsed as a CSS {{CSSxRef("&lt;integer&gt;")}}. If it is not valid, that is not an integer or out of the range accepted by the CSS property, the default value is used.<br>
     Leading and trailing spaces are stripped.</td>
    <td><code>0</code>, or, if <code>0</code> is not a valid value for the property, the property's minimum value.</td>
   </tr>
   <tr>
    <td><code>number</code> {{Experimental_Inline}}</td>
    <td style="white-space: nowrap;">{{CSSxRef("&lt;number&gt;")}}</td>
    <td>The attribute value is parsed as a CSS {{CSSxRef("&lt;number&gt;")}}. If it is not valid, that is not a number or out of the range accepted by the CSS property, the default value is used.<br>
     Leading and trailing spaces are stripped.</td>
    <td><code>0</code>, or, if <code>0</code> is not a valid value for the property, the property's minimum value.</td>
   </tr>
   <tr>
    <td><code>length</code> {{Experimental_Inline}}</td>
    <td style="white-space: nowrap;">{{CSSxRef("&lt;length&gt;")}}</td>
    <td>The attribute value is parsed as a CSS {{CSSxRef("&lt;length&gt;")}} dimension, that is including the unit (e.g. <code>12.5em</code>). If it is not valid, that is not a length or out of the range accepted by the CSS property, the default value is used.<br>
     If the given unit is a relative length, <code>attr()</code> computes it to an absolute length.<br>
     Leading and trailing spaces are stripped.</td>
    <td><code>0</code>, or, if <code>0</code> is not a valid value for the property, the property's minimum value.</td>
   </tr>
   <tr>
    <td><code>em</code>, <code>ex</code>, <code>px</code>, <code>rem</code>, <code>vw</code>, <code>vh</code>, <code>vmin</code>, <code>vmax</code>, <code>mm</code>, <code>cm</code>, <code>in</code>, <code>pt</code>, or <code>pc</code> {{Experimental_Inline}}</td>
    <td style="white-space: nowrap;">{{CSSxRef("&lt;length&gt;")}}</td>
    <td>The attribute value is parsed as a CSS {{CSSxRef("&lt;number&gt;")}}, that is without the unit (e.g. <code>12.5</code>), and interpreted as a {{CSSxRef("&lt;length&gt;")}} with the specified unit. If it is not valid, that is not a number or out of the range accepted by the CSS property, the default value is used.<br>
     If the given unit is a relative length, <code>attr()</code> computes it to an absolute length.<br>
     Leading and trailing spaces are stripped.</td>
    <td><code>0</code>, or, if <code>0</code> is not a valid value for the property, the property's minimum value.</td>
   </tr>
   <tr>
    <td><code>angle</code> {{Experimental_Inline}}</td>
    <td style="white-space: nowrap;">{{CSSxRef("&lt;angle&gt;")}}</td>
    <td>The attribute value is parsed as a CSS {{CSSxRef("&lt;angle&gt;")}} dimension, that is including the unit (e.g. <code>30.5deg</code>). If it is not valid, that is not an angle or out of the range accepted by the CSS property, the default value is used.<br>
     Leading and trailing spaces are stripped.</td>
    <td><code>0deg</code>, or, if <code>0deg</code> is not a valid value for the property, the property's minimum value.</td>
   </tr>
   <tr>
    <td><code>deg</code>, <code>grad</code>, <code>rad</code> {{Experimental_Inline}}</td>
    <td style="white-space: nowrap;">{{CSSxRef("&lt;angle&gt;")}}</td>
    <td>The attribute value is parsed as a CSS {{CSSxRef("&lt;number&gt;")}}, that is without the unit (e.g. <code>12.5</code>), and interpreted as an {{CSSxRef("&lt;angle&gt;")}} with the specified unit. If it is not valid, that is not a number or out of the range accepted by the CSS property, the default value is used.<br>
     Leading and trailing spaces are stripped.</td>
    <td><code>0deg</code>, or, if <code>0deg</code> is not a valid value for the property, the property's minimum value.</td>
   </tr>
   <tr>
    <td><code>time</code> {{Experimental_Inline}}</td>
    <td style="white-space: nowrap;">{{CSSxRef("&lt;time&gt;")}}</td>
    <td>The attribute value is parsed as a CSS {{CSSxRef("&lt;time&gt;")}} dimension, that is including the unit (e.g. <code>30.5ms</code>). If it is not valid, that is not a time or out of the range accepted by the CSS property, the default value is used.<br>
     Leading and trailing spaces are stripped.</td>
    <td><code>0s</code>, or, if <code>0s</code> is not a valid value for the property, the property's minimum value.</td>
   </tr>
   <tr>
    <td><code>s</code>, <code>ms</code> {{Experimental_Inline}}</td>
    <td style="white-space: nowrap;">{{CSSxRef("&lt;time&gt;")}}</td>
    <td>The attribute value is parsed as a CSS {{CSSxRef("&lt;number&gt;")}}, that is without the unit (e.g. <code>12.5</code>), and interpreted as an{{CSSxRef("&lt;time&gt;")}} with the specified unit. If it is not valid, that is not a number or out of the range accepted by the CSS property, the default value is used.<br>
     Leading and trailing spaces are stripped.</td>
    <td><code>0s</code>, or, if <code>0s</code> is not a valid value for the property, the property's minimum value.</td>
   </tr>
   <tr>
    <td><code>frequency</code> {{Experimental_Inline}}</td>
    <td style="white-space: nowrap;">{{CSSxRef("&lt;frequency&gt;")}}</td>
    <td>The attribute value is parsed as a CSS {{CSSxRef("&lt;frequency&gt;")}} dimension, that is including the unit (e.g. <code>30.5kHz</code>). If it is not valid, that is not a frequency or out of the range accepted by the CSS property, the default value is used.</td>
    <td><code>0Hz</code>, or, if <code>0Hz</code> is not a valid value for the property, the property's minimum value.</td>
   </tr>
   <tr>
    <td><code>Hz</code>, <code>kHz</code> {{Experimental_Inline}}</td>
    <td style="white-space: nowrap;">{{CSSxRef("&lt;frequency&gt;")}}</td>
    <td>The attribute value is parsed as a CSS {{CSSxRef("&lt;number&gt;")}}, that is without the unit (e.g. <code>12.5</code>), and interpreted as a {{CSSxRef("&lt;frequency&gt;")}} with the specified unit. If it is not valid, that is not a number or out of the range accepted by the CSS property, the default value is used.<br>
     Leading and trailing spaces are stripped.</td>
    <td><code>0Hz</code>, or, if <code>0Hz</code> is not a valid value for the property, the property's minimum value.</td>
   </tr>
   <tr>
    <td><code>%</code> {{Experimental_Inline}}</td>
    <td style="white-space: nowrap;">{{CSSxRef("&lt;percentage&gt;")}}</td>
    <td>The attribute value is parsed as a CSS {{CSSxRef("&lt;number&gt;")}}, that is without the unit (e.g. <code>12.5</code>), and interpreted as a {{CSSxRef("&lt;percentage&gt;")}}. If it is not valid, that is not a number or out of the range accepted by the CSS property, the default value is used.<br>
     If the given value is used as a length, <code>attr()</code> computes it to an absolute length.<br>
     Leading and trailing spaces are stripped.</td>
    <td><code>0%</code>, or, if <code>0%</code> is not a valid value for the property, the property's minimum value.</td>
   </tr>
  </tbody>
 </table>
 </dd>
 <dt><code>&lt;fallback&gt;</code> {{Experimental_Inline}}</dt>
 <dd>The value to be used if the associated attribute is missing or contains an invalid value. If not set, CSS will use the default value defined for each <code>&lt;type-or-unit&gt;</code>.</dd>
</dl>

<h3 id="Formal_syntax">Formal syntax</h3>

<pre class="syntaxbox notranslate">{{CSSSyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="content_property">content property</h3>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;p data-foo="hello"&gt;world&lt;/p&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css highlight[2] notranslate">[data-foo]::before {
  content: attr(data-foo) " ";
}</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample("content_property", "100%", 50)}}</p>

<h3 id="&lt;color&gt;_value">&lt;color&gt; value</h3>

<p>{{SeeCompatTable}}</p>

<div id="color-value">
<h4 id="HTML_2">HTML</h4>

<pre class="brush: html notranslate">&lt;div class="background" data-background="lime"&gt;background expected to be red if your browser does not support advanced usage of attr()&lt;/div&gt;</pre>

<h4 id="CSS_2">CSS</h4>

<div class="hidden">
<pre class="brush: css notranslate">.background {
  height: 100vh;
}</pre>
</div>

<pre class="brush: css highlight[6] notranslate">.background {
  background-color: red;
}

.background[data-background] {
  background-color: attr(data-background color, red);
}</pre>
</div>

<p>{{EmbedLiveSample("color-value", "100%", 50)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS4 Values", "#attr-notation", "attr()")}}</td>
   <td>{{Spec2("CSS4 Values")}}</td>
   <td>Changed it to work like {{CSSxRef("var()")}}. Property values involving <code>attr()</code> are valid at parse time, and the validation of the attribute value is deferred to computed value time.</td>
  </tr>
  <tr>
   <td>{{SpecName("CSS3 Values", "#attr-notation", "attr()")}}</td>
   <td>{{Spec2("CSS3 Values")}}</td>
   <td>
    <p>Added two optional parameters;<br>
     can be used on all properties;<br>
     may return values other than {{CSSxRef("&lt;string&gt;")}}.</p>
    These changes are experimental and may be dropped during the CR phase if browser support is too small.</td>
  </tr>
  <tr>
   <td>{{SpecName("CSS2.1", "generate.html#x18", "attr()")}}</td>
   <td>{{Spec2("CSS2.1")}}</td>
   <td>Limited to the {{CSSxRef("content")}} property;<br>
    always returns a {{CSSxRef("&lt;string&gt;")}}.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.types.attr")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/CSS/Attribute_selectors">Attribute selectors</a></li>
 <li><a href="/en-US/docs/Web/HTML/Global_attributes/data-*">HTML <code>data-*</code> attributes</a></li>
 <li><a href="/en-US/docs/Web/SVG/Attribute/data-*">SVG <code>data-*</code> attributes</a></li>
</ul>
